Index: /branches/gui/src/lib/gui/gl/glgui_text.cc
===================================================================
--- /branches/gui/src/lib/gui/gl/glgui_text.cc	(revision 10068)
+++ /branches/gui/src/lib/gui/gl/glgui_text.cc	(revision 10069)
@@ -50,5 +50,5 @@
     this->_text.setFont("fonts/final_frontier.ttf", 20);
     this->_text.setLineWidth(400);
-    this->_text.setDotsPosition(LimitedWidthText::Begin);
+//     this->_text.setDotsPosition(LimitedWidthText::Begin);
     this->_text.setColor(foregroundColor());
     this->_text.setVisibility(false);
Index: /branches/gui/src/world_entities/questGUI/quest_gui.cc
===================================================================
--- /branches/gui/src/world_entities/questGUI/quest_gui.cc	(revision 10068)
+++ /branches/gui/src/world_entities/questGUI/quest_gui.cc	(revision 10069)
@@ -59,8 +59,5 @@
   this->toList(OM_GROUP_00);
   
-  this->questBox = NULL;
-
-  this->currentlyOpened = NULL;
-  
+  this->questBox = NULL;  
 
   if( root != NULL)
@@ -94,6 +91,10 @@
    LoadParam(root, "quest-picture", this, QuestGUI, setQuestPicture)
        .describe("sets the picture of a quest");
-   LoadParam(root, "quest-outline", this, QuestGUI, setQuestOutline)
-       .describe("sets the outline of a quiest");
+   LoadParam(root, "quest-difficulty", this, QuestGUI, setQuestDifficulty)
+       .describe("sets the difficulty of a quest");
+   LoadParam(root, "reward-description", this, QuestGUI, setRewardDescription)
+       .describe("sets the description of a reward");
+   LoadParam(root, "reward-picture", this, QuestGUI, setRewardPicture)
+       .describe("sets the Picture of a reward");
    
 }
@@ -107,26 +108,61 @@
   if (questBox == NULL)
   {
-    this->questBox= new OrxGui::GLGuiBox();
+    this->questBox= new OrxGui::GLGuiBox(OrxGui::Vertical);
     
-    OrxGui::GLGuiBox* labelBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
-    //labelBox->setWidgetSize(100, 200);
+    OrxGui::GLGuiBox* headerBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
+    {
+      OrxGui::GLGuiImage* questImage = new OrxGui::GLGuiImage();
+      questImage->setWidgetSize(100, 100);
+      questImage->loadImageFromFile(questPicture);
+      questImage->show();
+      headerBox->pack(questImage);
+      
+      OrxGui::GLGuiBox* outlineBox = new OrxGui::GLGuiBox(OrxGui::Vertical);
+      {
+        OrxGui::GLGuiText* questDifficulty = new OrxGui::GLGuiText();
+        questDifficulty->setText(this->questDifficulty);
+        outlineBox->pack(questDifficulty);
+      }
+      headerBox->pack(outlineBox);
+      
+    }
     
-    OrxGui::GLGuiText* questTxt = new OrxGui::GLGuiText();
-    questTxt->setText(this->questDescription);
-    labelBox->pack(questTxt);
+    OrxGui::GLGuiBox* labelBox = new OrxGui::GLGuiBox(OrxGui::Vertical);
+    { 
+      OrxGui::GLGuiText* questTxt = new OrxGui::GLGuiText();
+      questTxt->setText(this->questDescription);
+      labelBox->pack(questTxt);
+    }
     
-    OrxGui::GLGuiImage* image = new OrxGui::GLGuiImage();
-    image->setWidgetSize(100, 100);
-    image->loadImageFromFile(questPicture);
-    image->show();
+    
+    OrxGui::GLGuiBox* rewardBox = new OrxGui::GLGuiBox(OrxGui::Vertical);
+    {
+      OrxGui::GLGuiImage* rewardImage = new OrxGui::GLGuiImage();
+      rewardImage->setWidgetSize(50, 50);
+      rewardImage->loadImageFromFile(rewardPicture);
+      rewardImage->show();
+      rewardBox->pack(rewardImage);
+    
+      OrxGui::GLGuiText* rewardTxt = new OrxGui::GLGuiText();
+      rewardTxt->setText(this->rewardDescription);
+      rewardBox->pack(rewardTxt);
+    }
+    
+    OrxGui::GLGuiBox* answerBox = new OrxGui::GLGuiBox(OrxGui::Horizontal);
+    {
+      OrxGui::GLGuiButton* acceptButton = new OrxGui::GLGuiPushButton("Accept");
+      answerBox->pack(acceptButton);
+      
+      OrxGui::GLGuiButton* refuseButton = new OrxGui::GLGuiPushButton("Refuse");
+      answerBox->pack(refuseButton);
+    }
+    
+    this->questBox->pack(headerBox);
+    this->questBox->pack(labelBox);
+    this->questBox->pack(rewardBox);
+    this->questBox->pack(answerBox);
+    this->questBox->showAll();
     
     this->questBox->setAbsCoor2D(300, 40);
-    labelBox->setRelCoor2D(300, 300);
-    image->setRelCoor2D(0, 0);
-    
-    this->questBox->pack(image);
-    this->questBox->pack(labelBox);
-    this->questBox->showAll();
-    
     OrxGui::GLGuiHandler::getInstance()->activate();
     OrxGui::GLGuiHandler::getInstance()->activateCursor();
Index: /branches/gui/src/world_entities/questGUI/quest_gui.h
===================================================================
--- /branches/gui/src/world_entities/questGUI/quest_gui.h	(revision 10068)
+++ /branches/gui/src/world_entities/questGUI/quest_gui.h	(revision 10069)
@@ -5,4 +5,5 @@
 #include "world_entity.h"
 #include "glgui.h"
+#include <glgui_image.h>
 #include <vector>
 
@@ -22,8 +23,10 @@
 
    /** @param questName sets the name of this quest */
-   inline void setQuestName(const std::string& questName) { this->questName = questName; }
-   inline void setQuestDescription(const std::string& questDescription) { this->questDescription = questDescription; }
-   inline void setQuestPicture(const std::string& questPicture) { this->questPicture = questPicture; }
-   inline void setQuestOutline(const std::string& questOutline) { this->questOutline = questOutline; }
+   inline void setQuestName(const std::string& questName)                { this->questName = questName; }
+   inline void setQuestDescription(const std::string& questDescription)  { this->questDescription = questDescription; }
+   inline void setQuestPicture(const std::string& questPicture)          { this->questPicture = questPicture; }
+   inline void setQuestDifficulty(const std::string& questDifficulty)    { this->questDifficulty = questDifficulty; }
+   inline void setRewardDescription(const std::string& rewardDescription){ this->rewardDescription  = rewardDescription; }
+   inline void setRewardPicture(const std::string& rewardPicture)        { this->rewardPicture  = rewardPicture; }
    void guiInit();
 
@@ -33,9 +36,16 @@
     std::string             questDescription;
     std::string             questPicture;
-    std::string             questOutline;
+    std::string             questDifficulty;
+    std::string             rewardDescription;
+    std::string             rewardPicture;
     
+    OrxGui::GLGuiBox*       headerBox;
+    OrxGui::GLGuiBox*       outlineBox; 
+    OrxGui::GLGuiBox*       labelBox;
     OrxGui::GLGuiBox*       questBox;
-
-    OrxGui::GLGuiBox*       currentlyOpened;
+    OrxGui::GLGuiImage*     questImage;
+    OrxGui::GLGuiBox*       rewardBox;
+    OrxGui::GLGuiImage*     rewardImage;
+    OrxGui::GLGuiBox*       answerBox;
 
     OrxSound::SoundSource*  selectorSource;