Index: code/branches/pickupsFS14/data/levels/jump.oxw
===================================================================
--- code/branches/pickupsFS14/data/levels/jump.oxw	(revision 10051)
+++ code/branches/pickupsFS14/data/levels/jump.oxw	(revision 10074)
@@ -3,5 +3,5 @@
  description = "Jump in space!"
  tags = "minigame"
- screenshot = "pong.png"
+ screenshot = "jump.png"
 />
 
@@ -21,16 +21,19 @@
 </Template>
 
-
+<Template name=figureLeftHand defaults=0>
+  <Model position="4.0,0.0,5.0" mesh="FigureLeftHand.mesh" scale=1 pitch=90>
+  </Model>
+</Template>
+
+<Template name=figureRightHand defaults=0>
+  <Model position="-4.0,0.0,5.0" mesh="FigureRightHand.mesh" scale=1 pitch=90>
+  </Model>
+</Template>
 
 <Template name=jumpFigureTemplate>
-  <JumpFigure camerapositiontemplate=jumpfigurecameras mouseFactor="100.0">
-    <attached>
-      <Model position="0,0,0" mesh="sphere.mesh" scale=4 />
-    </attached>
-  <!--
-      <controller>
-        <HumanController />
-      </controller>    
-    -->
+  <JumpFigure camerapositiontemplate=jumpfigurecameras mouseFactor="100.0" modelLefthand=figureLeftHand  modelRighthand=figureRightHand rocketPos=10.0 propellerPos=10.0 bootsPos=-5.2 jumpSpeed=250.0 handMinAngle=-20 handMaxAngle=75 handSpeed=250 rocketSpeed=250.0 propellerSpeed=150.0>
+    <attached>
+      <Model position="0,0,0" mesh="Figure.mesh" scale=1 pitch=90/>
+    </attached>
   </JumpFigure>
 </Template>
@@ -39,5 +42,5 @@
   <JumpProjectile>
     <attached>
-      <Model mesh="Projectile.mesh" scale=1.2  pitch=90/>
+      <Model mesh="Projectile.mesh" scale=1  pitch=90/>
       <ParticleEmitter scale=1 pitch=0 roll=0 position="0, 0, 0" source="Orxonox/thruster3" lifetime=2.0 loop=1 startdelay=0.0 />
     </attached>
@@ -46,7 +49,8 @@
 
 <Template name=jumpPlatformStaticTemplate>
-  <JumpPlatformStatic>
-    <attached>
-      <Model mesh="Platform01.mesh" scale=1.2  pitch=90/>
+  <JumpPlatformStatic height=3 width=19>
+    <attached>
+      <Model mesh="Platform01.mesh" scale=1  pitch=90/>
+      <Backlight scale=0.2 colour="0.9, 0.4, 0.0" width=7 length=500 lifetime=0.3 elements=20 trailmaterial="Trail/backlighttrail" material="Examples/Flare" loop=1 />
     </attached>
   </JumpPlatformStatic>
@@ -54,7 +58,7 @@
 
 <Template name=jumpPlatformHMoveTemplate>
-  <JumpPlatformHMove>
-    <attached>
-      <Model mesh="Platform02.mesh" scale=1.2  pitch=90/>
+  <JumpPlatformHMove height=3 width=19>
+    <attached>
+      <Model mesh="Platform02.mesh" scale=1  pitch=90/>
       <Backlight scale=0.2 colour="0.1, 0.1, 1.0" width=7 length=500 lifetime=0.3 elements=20 trailmaterial="Trail/backlighttrail" material="Examples/Flare" loop=1 />
     </attached>
@@ -63,8 +67,8 @@
 
 <Template name=jumpPlatformVMoveTemplate>
-  <JumpPlatformVMove>
-    <attached>
-      <Model mesh="Platform03.mesh" scale=1.2  pitch=90/>
-      <Backlight scale=0.2 colour="1.0, 1.0, 1.0" width=7 length=500 lifetime=0.3 elements=20 trailmaterial="Trail/backlighttrail" material="Examples/Flare" loop=1 />
+  <JumpPlatformVMove height=3 width=19>
+    <attached>
+      <Model mesh="Platform03.mesh" scale=1  pitch=90/>
+      <Backlight scale=0.2 colour="1.0, 0.1, 1.0" width=7 length=500 lifetime=0.3 elements=20 trailmaterial="Trail/backlighttrail" material="Examples/Flare" loop=1 />
     </attached>
   </JumpPlatformVMove>
@@ -72,9 +76,8 @@
 
 <Template name=jumpPlatformDisappearTemplate>
-  <JumpPlatformDisappear>
-    <attached>
-      <Model mesh="Platform04.mesh" scale=1.2  pitch=90/>
-      <Backlight scale=0.2 colour="0.0, 0.0, 1.0" width=7 length=500 lifetime=0.3 elements=20 trailmaterial="Trail/backlighttrail" material="Examples/Flare" loop=1 />
-            <Backlight scale=0.2 colour="0.0, 1.0, 0.1" width=7 length=500 lifetime=0.3 elements=20 trailmaterial="Trail/backlighttrail" material="Examples/Flare" loop=1 />       
+  <JumpPlatformDisappear height=3 width=19>
+    <attached>
+      <Model mesh="Platform04.mesh" scale=1  pitch=90/>
+      <Backlight scale=0.2 colour="0.1, 1.0, 0.1" width=7 length=500 lifetime=0.3 elements=20 trailmaterial="Trail/backlighttrail" material="Examples/Flare" loop=1 />
     </attached>
   </JumpPlatformDisappear>
@@ -82,10 +85,10 @@
 
 <Template name=jumpPlatformTimerTemplate>
-  <JumpPlatformTimer effectPath="Orxonox/BigExplosion1part2" effectStartTime="0.4">
-    <attached>
-      <Model mesh="Platform05.mesh" scale=1.2  pitch=90/>
+  <JumpPlatformTimer height=3 width=19 effectPath="Orxonox/BigExplosion1part2" effectStartTime="0.4">
+    <attached>
+      <Model mesh="Platform05.mesh" scale=1  pitch=90/>
+      <ParticleEmitter scaled3D="5.0, 1.0, 2.0" pitch=0 roll=0 position="-4, 0, -2.0" source="Orxonox/thruster3" lifetime=2.0 loop=1 startdelay=0.0 />
       <ParticleEmitter scaled3D="5.0, 1.0, 2.0" pitch=0 roll=0 position="0, 0, -2.0" source="Orxonox/thruster3" lifetime=2.0 loop=1 startdelay=0.0 />
-
-      <!-- <ParticleSpawner name=hiteffect position="0,0,0" source="Orxonox/sparks2" lifetime=0.01 autostart=0 mainstate=spawn /> -->
+      <ParticleEmitter scaled3D="5.0, 1.0, 2.0" pitch=0 roll=0 position="4, 0, -2.0" source="Orxonox/thruster3" lifetime=2.0 loop=1 startdelay=0.0 />      
     </attached>
   </JumpPlatformTimer>
@@ -93,7 +96,7 @@
 
 <Template name=jumpPlatformFakeTemplate>
-  <JumpPlatformFake>
-    <attached>
-      <Model mesh="Platform06.mesh" scale=1.2  pitch=90/>
+  <JumpPlatformFake height=3 width=19>
+    <attached>
+      <Model mesh="Platform06.mesh" scale=1  pitch=90/>
       <ParticleEmitter scale3D="0.2,0.2,0.2" pitch=0 roll=0 position="0, 0, -2.5" source="Orxonox/sparks" lifetime=1.0 loop=1 startdelay=0.0 />
     </attached>
@@ -101,12 +104,91 @@
 </Template>
 
-<Template name=jumpPlatformEnemy1Template>
-  <JumpEnemy>
-    <attached>
-      <Model mesh="cube.mesh" scale3D="10.0, 4.0, 4.0"  pitch=90/>
-    </attached>
-  </JumpEnemy>
-</Template>
-
+<Template name=jumpEnemy1Template>
+  <JumpEnemy height=7 width=18>
+    <attached>
+      <Model mesh="Enemy1.mesh" scale=1  pitch=90/>
+      <FadingBillboard active=true scale=0.09 position="0, 0, 10" colour="0.2, 1.0, 0.65, 1.0" material="Examples/Flare" turnontime=0.5 turnofftime=0.5 />
+      <Backlight scale=0.33 name=bltest position="0, 0, -10" colour="0.6, 0.8, 0.75, 0.7" width=25 length=1000 lifetime=1 elements=30 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Examples/Flare" />            
+    </attached>
+  </JumpEnemy>
+</Template>
+
+<Template name=jumpEnemy2Template>
+  <JumpEnemy height=8 width=20>
+    <attached>
+      <Model mesh="Enemy2.mesh" scale=1  pitch=90/>
+      <MovableEntity position="-17, 0, 4" rotationaxis="0, 1, 0" rotationrate=500 >
+        <attached>
+          <Model mesh="Enemy2Wing.mesh" scale=1 pitch=90/>
+        </attached>
+      </MovableEntity>      
+      <MovableEntity position="17, 0, 4" rotationaxis="0, 1, 0" rotationrate=500 >
+        <attached>
+          <Model mesh="Enemy2Wing.mesh" scale=1 pitch=90/>
+        </attached>
+      </MovableEntity> 
+      <ParticleEmitter scale3D="1.0,1.0,1.0" pitch=0 roll=0 position="-1, 0, -3" source="Orxonox/laser" lifetime=1.0 loop=1 startdelay=0.0 />
+    </attached>
+  </JumpEnemy>
+</Template>
+
+<Template name=jumpEnemy3Template>
+  <JumpEnemy height=8.2 width=11.2>
+    <attached>
+      <Model mesh="Enemy3.mesh" scale=1  pitch=90/>
+      <Backlight scale3D="0.1, 0.1, 1.0" position="0, -11, -4" colour="1.0, 0.0, 0.9, 1.0" width=1 length=1 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1"/>
+      <Backlight scale3D="0.1, 0.1, 1.0" position="6.32, 5.5, -4" colour="1.0, 0.0, 0.9, 1.0" width=1 length=1 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1"/>
+      <Backlight scale3D="0.1, 0.1, 1.0" position="-6.32, 5.5, -4" colour="1.0, 0.0, 0.9, 1.0" width=1 length=1 lifetime=2 elements=50 trailmaterial="Trail/backlighttrail" turnontime=1 turnofftime=1 material="Flares/ThrusterFlare1"/>            
+    </attached>
+  </JumpEnemy>
+</Template>
+
+<Template name=jumpEnemy4Template>
+  <JumpEnemy height=7.5 width=21.5 rotationaxis="0, 0, 1" rotationrate=40 >
+    <attached>
+      <Model mesh="Enemy4.mesh" scale=1  pitch=90/>
+    </attached>
+  </JumpEnemy>
+</Template>
+
+<Template name=jumpSpringTemplate>
+  <JumpSpring height=6 width=9.25>
+    <attached>
+      <Model mesh="Spring.mesh" scale=1  rotationaxis="0, 0, 1" pitch=90 position="0.0, 0.0, 0.0"/>
+    </attached>
+  </JumpSpring>
+</Template>
+
+<Template name=jumpRocketTemplate>
+  <JumpRocket height=8.5 width=13.5>
+    <attached>
+      <Model mesh="Rocket.mesh" scale=1  pitch=90 position="0.0, 0.0, 1.0"/>
+    </attached>
+  </JumpRocket>
+</Template>
+
+<Template name=jumpPropellerTemplate>
+  <JumpPropeller height=4 width=15.5>
+    <attached>
+      <Model mesh="Propeller.mesh" scale=1  pitch=90 position="0.0, 0.0, 1.0"/>
+    </attached>
+  </JumpPropeller>
+</Template>
+
+<Template name=jumpBootsTemplate>
+  <JumpBoots height=5.2 width=3.5>
+    <attached>
+      <Model mesh="Boots.mesh" scale=1  pitch=90 position="0.0, 0.0, 1.0"/>
+    </attached>
+  </JumpBoots>
+</Template>
+
+<Template name=jumpShieldTemplate>
+  <JumpShield height=1.55 width=15.5>
+    <attached>
+      <Model mesh="Shield.mesh" scale=1 pitch=90 position="0.0, 0.0, 1.0"/>
+    </attached>
+  </JumpShield>
+</Template>
 
 <Level gametype = "Jump">
@@ -129,6 +211,7 @@
           name=jumpcenter
           dimension="120,80"
-          sectionLength="100"
-          platformLength="12"
+          sectionLength="150"
+          platformSpeed="20"
+          cameraOffset="10"
 
           platformStaticTemplate=jumpPlatformStaticTemplate
@@ -137,8 +220,17 @@
           platformDisappearTemplate=jumpPlatformDisappearTemplate
           platformTimerTemplate=jumpPlatformTimerTemplate
-          platformFakeTemplate=jumpPlatformFakeTemplate
-          enemy1Template=jumpPlatformEnemy1Template
+          platformFakeTemplate=jumpPlatformFakeTemplate          
           figureTemplate=jumpFigureTemplate
-          projectileTemplate=jumpProjectileTemplate>
+          projectileTemplate=jumpProjectileTemplate
+          springTemplate=jumpSpringTemplate
+          rocketTemplate=jumpRocketTemplate
+          propellerTemplate=jumpPropellerTemplate
+          bootsTemplate=jumpBootsTemplate
+          shieldTemplate=jumpShieldTemplate
+          enemy1Template=jumpEnemy1Template
+          enemy2Template=jumpEnemy2Template
+          enemy3Template=jumpEnemy3Template
+          enemy4Template=jumpEnemy4Template
+          >
 
           <attached>
@@ -150,33 +242,12 @@
             <Model position="0,0,-1000" mesh="Platform05.mesh" scale="1" />
             <Model position="0,0,-1000" mesh="Platform06.mesh" scale="1" />
-
             <Model position="0,0,-1000" mesh="Projectile.mesh" scale="1" />
-
-            <!--                   
-            <Model position="0,0,60" mesh="cube.mesh" scale3D="105,1,1" />
-            <Model position="0,0,-60" mesh="cube.mesh" scale3D="105,1,1" />            
-            
-            <ParticleSpawner name=scoreeffect_right position="120,0, 45" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
-            <ParticleSpawner name=scoreeffect_right position="120,0, 30" source="Orxonox/BigExplosion1part2" lifetime=3.0 autostart=0 />
-            <ParticleSpawner name=scoreeffect_right position="120,0, 15" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
-            <ParticleSpawner name=scoreeffect_right position="120,0,  0" source="Orxonox/BigExplosion1part2" lifetime=0.1 autostart=0 />
-            <ParticleSpawner name=scoreeffect_right position="120,0,-15" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
-            <ParticleSpawner name=scoreeffect_right position="120,0,-30" source="Orxonox/BigExplosion1part2" lifetime=3.0 autostart=0 />
-            <ParticleSpawner name=scoreeffect_right position="120,0,-45" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
-
-            <ParticleSpawner name=scoreeffect_left position="-120,0, 45" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
-            <ParticleSpawner name=scoreeffect_left position="-120,0, 30" source="Orxonox/BigExplosion1part2" lifetime=3.0 autostart=0 />
-            <ParticleSpawner name=scoreeffect_left position="-120,0, 15" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
-            <ParticleSpawner name=scoreeffect_left position="-120,0,  0" source="Orxonox/BigExplosion1part2" lifetime=0.1 autostart=0 />
-            <ParticleSpawner name=scoreeffect_left position="-120,0,-15" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
-            <ParticleSpawner name=scoreeffect_left position="-120,0,-30" source="Orxonox/BigExplosion1part2" lifetime=3.0 autostart=0 />
-            <ParticleSpawner name=scoreeffect_left position="-120,0,-45" source="Orxonox/sparks2" lifetime=0.1 autostart=0 />
-            
-            <?lua
-              for i = 1, 15, 1 do
-            ?>
-              <ParticleSpawner name=scoreeffect_center position="<?lua print(math.random() * 200 - 100) ?>,0,<?lua print(math.random() * 120 - 60) ?>" source="Orxonox/sparks2" lifetime=0.02 autostart=0 startdelay=<?lua print(math.random() * 0.7) ?> />
-            <?lua end ?>
-            -->
+            <Model position="0,0,-1000" mesh="Figure.mesh" scale="1" />
+            <Model position="0,0,-1000" mesh="Enemy1.mesh" scale="1" />
+            <Model position="0,0,-1000" mesh="Enemy2.mesh" scale="1" />
+            <Model position="0,0,-1000" mesh="Enemy3.mesh" scale="1" />
+            <Model position="0,0,-1000" mesh="Enemy4.mesh" scale="1" />
+            <Model position="0,0,-1000" mesh="Spring.mesh" scale="1" />
+            <Model position="0,0,-1000" mesh="Rocket.mesh" scale="1" />
           </attached>
         </JumpCenterpoint>
@@ -217,56 +288,4 @@
     </EventDispatcher>
 
-    <?lua
-      dofile("includes/CuboidSpaceStation.lua")
-    ?>
-
-    <StaticEntity pitch=15>
-      <attached>
-        <MovableEntity rotationrate="-4.15786" rotationaxis="0,0,1">
-          <attached>
-            <StaticEntity position="-2500,0,0" yaw=90 pitch=90>
-              <attached>
-                <?lua
-                  createSpaceStationPar(0,2,1,2,1,4,1,50)
-                ?>
-              </attached>
-            </StaticEntity>
-          </attached>
-        </MovableEntity>
-      </attached>
-    </StaticEntity>
-
-    <StaticEntity position="0,1200,-200" yaw=50 pitch=60 roll=45>
-      <attached>
-        <Model scale=10 mesh="Carrier.mesh" />
-        <Model position="0,30,20" scale=10 mesh="pirate.mesh" roll="180" />
-        <Model position="-80,-30,20" scale=10 mesh="pirate.mesh" roll="180" />
-      </attached>
-    </StaticEntity>
-
-    <StaticEntity pitch=70>
-      <attached>
-        <MovableEntity rotationaxis="0,0,1" rotationrate=8.5974>
-          <attached>
-            <StaticEntity yaw=-90 pitch=0 roll=90 position="800,0,0">
-              <attached>
-                <Model position="0,0,0" scale=10 mesh="satellite.mesh" />
-                <MovableEntity position="-4,0,20" velocity="0,0,0" rotationaxis="0,0,1" rotationrate=50>
-                  <attached>
-                    <Model position="0,0,0" scale=10 mesh="satellitedish.mesh"/>
-                  </attached>
-                </MovableEntity>
-                <!--
-                <ParticleEmitter pitch=-135 roll=30 position="-14, 3.5,-2.5" source="Orxonox/thruster3" lifetime=2.0 loop=1 startdelay=3.0 />
-                <ParticleEmitter pitch=135 roll=30 position="-14, 3.5,-9" source="Orxonox/thruster3" lifetime=2.0 loop=1 startdelay=3.0 />
-                <ParticleEmitter pitch=-45 roll=30 position="-14,-3.5,-2.5" source="Orxonox/thruster3" lifetime=2.0 loop=1 startdelay=3.0 />
-                <ParticleEmitter pitch=45 roll=30 position="-14,-3.5,-9" source="Orxonox/thruster3" lifetime=2.0 loop=1 startdelay=3.0 />
-              -->
-              </attached>
-            </StaticEntity>
-          </attached>
-        </MovableEntity>
-      </attached>
-    </StaticEntity>
   </Scene>
 </Level>